﻿using SFML.Window;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd
{
    public enum BodyColor { Blue, Green, Red, Count};
    public enum MouthType { Stupid, Angry, Sad, Count };
    public enum EyeType { Normal, Angry, Sad, Count };



    public class BobbleInfo : IEquatable<BobbleInfo>
    {
        public BodyColor color;
        public MouthType mouth;
        public EyeType eye;

        public BobbleInfo()
        {
            color = (BodyColor) MathUtil.Rand.Next(0, (int)BodyColor.Count);
            mouth = (MouthType) MathUtil.Rand.Next(0, (int)MouthType.Count);
            eye =   (EyeType)   MathUtil.Rand.Next(0, (int)EyeType.Count);
        }

        public BobbleInfo(BodyColor color, MouthType mouth, EyeType eye)
        {
            this.color = color;
            this.mouth = mouth;
            this.eye = eye;
        }

        public BobbleInfo(Vector3i vector)
        {
            this.color = (BodyColor)vector.x;
            this.mouth = (MouthType)vector.y;
            this.eye =   (EyeType)vector.z;
        }


        
        public bool IsEqual(BobbleInfo info2)
        {
            return color == info2.color && mouth == info2.mouth && eye == info2.eye;
        }

        public Vector3i GetVector()
        {
            return new Vector3i((int)color, (int)mouth, (int)eye);
        }



        public bool Equals(BobbleInfo other)
        {
            return IsEqual(other);
        }
    }
}
