﻿using BobbleCrowd.Entities;
using SFML.Graphics;
using SFML.Window;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd.Components
{
    public class ClickResponse : ACollisionResponse
    {
        private View view;
        private bool shoot;
        private float zoomFac;
        
        public ClickResponse()
        {

        }

        public override void OnCollision(Entities.Entity collidedEntity, IntersectionData data, bool firstCalled)
        {
            if (collidedEntity is Bobble && collidedEntity.Drawer.IsActive)
            {
                Bobble b = collidedEntity as Bobble;

                if (((Owner.World.mode as BobbleMixMode).bobbleThinker.Owner as Bobble).info.IsEqual(b.info))
                {
                    if(Owner.World.mode is BobbleMixMode)
                        (Owner.World.mode as BobbleMixMode).menu.AddPoints(1);
                }

                else
                {
                    if (Owner.World.mode is BobbleMixMode)
                        (Owner.World.mode as BobbleMixMode).menu.AddPoints(-1);
                }


                view = Owner.World.target.GetView();
                shoot = true;
                zoomFac =0.9f;
                view.Size = new Vector2f(zoomFac * Settings.WindowSize.X, zoomFac * Settings.WindowSize.Y);
                createBobbleParticle(Owner.Collider.Position, ((Bobble)collidedEntity).info);
                (Owner.World.mode as BobbleMixMode).RemoveBobble(b);
                Owner.CanCollide = false;
            }


          
        }

        public override void Update()
        {
         if(shoot && !Owner.World.endGame)
         {

             zoomFac += (float)Owner.World.Time.ElapsedTime.TotalMilliseconds/2500;
             if(zoomFac>1)
             {
                 zoomFac = 1;
                 shoot = false;
             }
             view.Size = new Vector2f(zoomFac * Settings.WindowSize.X, zoomFac * Settings.WindowSize.Y);
             Owner.World.target.SetView(view);

         }
        }

        public override void Init()
        {
            
        }

        private void createBobbleParticle(Vector2f position, BobbleInfo info)
        {

            for (int i = 0; i < 15; i++)
            {
                float scale = 0.3f;
                float size = scale * 48.0f;

                Entity particle = new Entity("Particle", new CircleCollider(size), position);
                

                MultiThinker thinker = new MultiThinker();
                particle.Thinker = thinker;


                thinker.AddThinker(new LinearSlowDownMover(position,Vec2f.RandomDir,2+MathUtil.Rand.NextFloat()*2));

                particle.Category = CollisionGroup.None;
                particle.Mask = CollisionGroup.None;
                particle.CanCollide = false;

                //particle.Response = new PushResponse(true, 0.5f);

                BobbleInfo cInfo = new BobbleInfo();

                cInfo.color = info.color;
                cInfo.eye = EyeType.Count;
                cInfo.mouth = MouthType.Count;

                particle.Drawer = new BobbleDraw(scale, cInfo);
                //bobble.Drawer = new BasicTextureDrawer(Game.Content.Load<Texture>("gfx/bodySprite.png"), false, true, scale, new IntRect(0, 0, 128, 128));

                Owner.World.AddEntity(particle);
            }

        }
    }
}
