﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd.Components
{
    public class DragDropResponse : ACollisionResponse
    {
        private Bobble draggingBobble;

        public DragDropResponse()
        {

        }


        public override void OnCollision(Entities.Entity collidedEntity, IntersectionData data, bool firstCalled)
        {
            if (collidedEntity is Bobble)
            {
                draggingBobble = (collidedEntity as Bobble);
                draggingBobble.Thinker.IsActive = false;
                draggingBobble.CanCollide = false;
                this.Owner.CanCollide = false;
            }
        }

        public override void Update()
        {
            if (draggingBobble != null)
            {
                if (MInput.IsPressed(SFML.Window.Mouse.Button.Left))
                {
                    draggingBobble.Collider.Position = MInput.WindowPos();
                }

                else if (MInput.IsReleased(SFML.Window.Mouse.Button.Left))
                {
                    if (draggingBobble.Collider.Position.X < 0 || draggingBobble.Collider.Position.X >= Settings.WindowSize.X || draggingBobble.Collider.Position.Y < 0 || draggingBobble.Collider.Position.Y >= Settings.WindowSize.Y)
                    {
                        Owner.World.RemoveEntity(draggingBobble);
                    }
                    else
                    {
                        draggingBobble.Thinker.IsActive = true;
                        draggingBobble.CanCollide = true;
                        draggingBobble = null;
                    }
                }

              
            }
        }

        public override void Init()
        {
           
        }
    }
}
