﻿using BobbleCrowd.GameStates;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd.Components
{
    public class SortZoneResponse : ACollisionResponse
    {
        private BodyColor color;
        public static float timeToEndSort;
        public static float JOIN_MENU_TIME = 13000;
        public static int zoneSize = 20;
        static List<Bobble> zoneRed = new List<Bobble>();
        static List<Bobble> zoneGreen = new List<Bobble>();
        static List<Bobble> zoneBlue = new List<Bobble>();

        public SortZoneResponse(BodyColor color)
        {
            this.color = color;
        }

        public override void OnCollision(Entities.Entity collidedEntity, IntersectionData data, bool firstCalled)
        {
            if (collidedEntity is Bobble)
            {
                Bobble bob = (collidedEntity as Bobble);
                bob.BobbleInZone();

                if (bob.info.color == color)
                {
                    (Owner.World.mode as BobbleSortMode).menu.AddPoints(1);

                    if ((int)bob.info.color == 0)
                        zoneBlue.Add((collidedEntity as Bobble));

                    else if ((int)bob.info.color == 1)
                        zoneGreen.Add((collidedEntity as Bobble));

                    else if ((int)bob.info.color == 2)
                        zoneRed.Add((collidedEntity as Bobble));

                   
                }

                else
                {
                    Owner.World.RemoveAllBobble(true);
                    timeToEndSort += (float)Owner.World.Time.ElapsedTime.TotalMilliseconds;
                }
            }


        }

        

        public override void Update()
        {



            if (timeToEndSort > 0)
                timeToEndSort += (float)Owner.World.Time.ElapsedTime.TotalMilliseconds;
            if(timeToEndSort>JOIN_MENU_TIME)
            {
                Owner.World.GetInGame().GetParent().SetGameState(new HighscoreTable());
                timeToEndSort = 0;
            }

            if(zoneGreen.Count>zoneSize)
            {
                for (int i = 0; i < 5; i++)
			    {
                    Owner.World.RemoveEntity(zoneGreen.ElementAt(0));
                    zoneGreen.RemoveAt(0);
			    }
            }
            if (zoneRed.Count > zoneSize)
            {
                for (int i = 0; i < 5; i++)
                {
                    Owner.World.RemoveEntity(zoneRed.ElementAt(0));
                    zoneRed.RemoveAt(0);
                }
            }
            if (zoneBlue.Count > zoneSize)
            {
                for (int i = 0; i < 5; i++)
                {
                    Owner.World.RemoveEntity(zoneBlue.ElementAt(0));
                    zoneBlue.RemoveAt(0);
                }
            }
        }

        public override void Init()
        {
           
        }
    }
}
