﻿using BobbleCrowd.World;
using SFML.Graphics;
using SFML.Window;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd.Components
{
    public class BasicTextureDrawer : ADrawer
    {
        private Sprite sprite;

        public bool rotateWithOwner;
        public bool moveWithOwner;

        private float startScale;
    //    public bool scaleWithOwner;

        public BasicTextureDrawer(Texture texture, bool rotateWithOwner, bool moveWithOwner, float scale)
        {
            sprite = new Sprite(texture);
            sprite.Origin = new SFML.Window.Vector2f(texture.Size.X / 2, texture.Size.Y / 2);
            sprite.Scale = new Vector2f(scale, scale);

            this.rotateWithOwner = rotateWithOwner;
            this.moveWithOwner = moveWithOwner;
            this.startScale = scale;
         //   this.scaleWithOwner = scaleWithOwner;
        }

        public BasicTextureDrawer(Texture texture, bool rotateWithOwner, bool moveWithOwner, float scale, IntRect sourceRect) 
            : this(texture, rotateWithOwner, moveWithOwner, scale)
        {
            sprite.TextureRect = sourceRect;


            this.sprite.Origin = new Vector2f(sourceRect.Width * 0.5f, sourceRect.Height * 0.5f);
        }

        public override void Init()
        {
            if(moveWithOwner)
                sprite.Position = Owner.Collider.Position;

            if(rotateWithOwner)
                sprite.Rotation = MathUtil.ToDegree(Owner.Collider.Rotation);

      //      if(scaleWithOwner)
        //        sprite.Scale = new Vector2f(Owner.Collider.Scale, Owner.Collider.Scale);
        }



        public override void Update()
        {
            if(moveWithOwner)
                sprite.Position = Owner.Collider.Position;

            if(rotateWithOwner)
                sprite.Rotation = MathUtil.ToDegree(Owner.Collider.Rotation);

           // if(scaleWithOwner)
          //      sprite.Scale = new Vector2f(Owner.Collider.Scale, Owner.Collider.Scale);

        }

        public override void Draw(RenderTarget target)
        {
            target.Draw(sprite);

            //Owner.Collider.DebugDraw(target, new Color(255, 0, 0, 127));
        }



    }
}
