﻿using SFML.Window;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd.Components
{
    //TODO: smooth rotation at controlPoints
    public class LinearPatrolMover : AThinker
    {
        List<Vector2f> controlPoints;

        int oldPointIndex;
        int newPointIndex;

        float speed;
        bool onPath = false;

        public LinearPatrolMover(List<Vector2f> points, float speed)
        {
            this.controlPoints = points;
            this.speed = speed;
        }

        public override void Update()
        {

            if (onPath)
            {
                if (Vec2f.EuclidianDistance(Owner.Collider.Position, controlPoints[newPointIndex]) < 1.0f)
                {
                    oldPointIndex = newPointIndex;
                    newPointIndex = (newPointIndex + 1) % controlPoints.Count;

                    Vector2f dir = Vec2f.Normalized(controlPoints[newPointIndex] - controlPoints[oldPointIndex]);

                    Owner.Collider.Direction = dir;
                }

                Owner.Collider.Direction = Vec2f.Normalized(controlPoints[newPointIndex] - Owner.Collider.Position);
            }

            else
            {
                if (Vec2f.EuclidianDistance(Owner.Collider.Position, controlPoints[oldPointIndex]) < 1.0f)
                    onPath = true;
                
                Owner.Collider.Direction = Vec2f.Normalized(controlPoints[oldPointIndex] - Owner.Collider.Position);
                
            }

            Owner.Collider.Move(Owner.Collider.Direction * speed);

        }

        public override void Init()
        {
            oldPointIndex = 0;
            newPointIndex = 1;

            onPath = false;
        }
    }
}
