﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd.Components
{
    public class MultiThinker : AThinker
    {
        private List<AThinker> thinkers;

        public MultiThinker()
        {
            thinkers = new List<AThinker>();
        }


        public void AddThinker(AThinker thinker)
        {
            thinkers.Add(thinker);
            thinker.Owner = this.Owner;
            thinker.Init();
        }

        public override void Update()
        {
            for (int i = 0; i < thinkers.Count; i++)
            {
                thinkers[i].Update();
            }
        }

        public override void Init()
        {
            for (int i = 0; i < thinkers.Count; i++)
            {
                this.thinkers[i].Owner = this.Owner;
                this.thinkers[i].Init();
            }
        }

        public override U GetComponentOfType<U>()
        {
            for (int i = 0; i < thinkers.Count; i++)
            {
                U maybeT = this.thinkers[i].GetComponentOfType<U>();

                if (maybeT != null)
                    return maybeT;
            }

            return null;
        }

    }
}
