﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd.Components
{
    public class TimedThinker : AThinker
    {
        private bool restart;

        private double maxTimer;
        private double curTimer;
        private Action timerAction;

        public TimedThinker(double timer, bool restart, Action timerAction)
        {
            this.maxTimer = timer;
            this.curTimer = timer;
            this.restart = restart;
            this.timerAction = timerAction;
        }

        public override void Update()
        {
            curTimer -= Owner.World.Time.ElapsedTime.TotalSeconds;

            if (curTimer <= 0)
            {
                timerAction();

                if (restart)
                    curTimer = maxTimer;
            }
            

        }

        public override void Init()
        {
           
        }
    }
}
