﻿
using SFML.Graphics;
using SFML.Window;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd
{
    /// <summary>
    /// Some data that contains information about the collision between two Polygons.
    /// </summary>
    public struct IntersectionData
    {
        /// <summary>
        /// Tells if the given objects even intersect.
        /// </summary>
        public bool Intersects
        {
            get { return depth != 0.0f; }
        }

        /// <summary>
        /// Is the depth of penetration.
        /// </summary>
        public float depth;

        /// <summary>
        /// Is the direction the intersection can be resolved with when multiplied with the penetrationValue.
        /// </summary>
        public Vector2f direction;


        /// <summary>
        /// Creates the collision data with intersection.
        /// </summary>
        /// <param name="penetrationValue">The depth of penetration.</param>
        /// <param name="separationDirection">The direction the intersection between two Polygons can be resolved.</param>
        public IntersectionData(float penetrationValue, Vector2f separationDirection)
        {
            this.depth = penetrationValue;

            this.direction = separationDirection;
        }

    }
}
