﻿using SFML.Window;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd
{
    public static class PolygonFactory
    {
        /*
        public static ConcaveCollider GetRegularStar(int numEdges, float radius)
        {
            List<ConvexCollider> list = new List<ConvexCollider>();

            float rad = MathUtil.TWO_PI / numEdges;
      
            for (int i = 0; i < numEdges; i++)
            {
                Vector2f current = Vec2f.DirectionFrom(-i * rad) * radius;

                Vector2f subNext = (current + Vec2f.DirectionFrom(-((i + 1) % numEdges) * rad) * radius) / 3.0f;

                Vector2f subPrev = (current + Vec2f.DirectionFrom(-((i + numEdges - 1) % numEdges) * rad) * radius) / 3.0f;

                Vector2f[] currentVertices = { subNext, Vec2f.Zero, subPrev, current };

                list.Add(new ConvexCollider(false, currentVertices));
            }

            return new ConcaveCollider(list, Vec2f.Zero, 4 * numEdges);
        }
        */
        public static Vector2f[] GetElipse(int numEdges, float radX, float radY)
        {
            Vector2f[] arr = new Vector2f[numEdges];

            double deltaRad = MathUtil.TWO_PI / numEdges;

            //TODO: swap sin and cos? -> need it in anticlockwise order
            for (int i = 0; i < numEdges; i++)
                arr[i] = new Vector2f((float)Math.Sin(i * deltaRad) * radX, (float)Math.Cos(i * deltaRad) * radY);

            return arr;
        }

        public static Vector2f[] GetBox(float radX, float radY)
        {
            Vector2f[] arr = new Vector2f[4];


            arr[0] = new Vector2f(-radX, -radY);
            arr[1] = new Vector2f(-radX, radY);

            arr[2] = new Vector2f(radX, radY);
            arr[3] = new Vector2f(radX, -radY);


            return arr;
        }

        public static Vector2f[] GetCircle(int numEdges, float rad)
        {
            return GetElipse(numEdges, rad, rad);
        }






    }
}
