﻿using SFML.Graphics;
using SFML.Window;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd.GameStates
{
    public class HighscoreEntry : IComparable<HighscoreEntry>
    {
        private String name;

        public int points;

        private Text text;

        public HighscoreEntry(String name, int points)
        {
            this.points = points;

            this.name = name;

            text = new Text(name + " " + points, Game.Content.Load<Font>(Strings.FONT_NAME));
        }

        public void Draw(RenderTarget target)
        {
            target.Draw(text);
        }

        public int CompareTo(HighscoreEntry other)
        {
            return this.points - other.points;
        }

        public Vector2f GetPosition()
        {
            return text.Position;
        }

        public void SetPositions(Vector2f val)
        {
            text.Position = val;
        }

        public override string ToString()
        {
            return String.Concat(points,",", name);
        }
    }
}

