﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd
{
    //TODO:
    public static class InputManager
    {
        public enum EAction {Activate, RotateLeft, RotateRight, Attack,       Count }

        //TODO: how to handle mapping /  encapsule this stuff down here in own class?
        private static SFML.Window.Joystick.Axis leftRight;
        private static SFML.Window.Joystick.Axis upDown;

        private static GInput gamepad;
        private static bool useGamePad;

        public static void CreateInputDevices(Game game, bool createGamePad, uint maxGamepadChecks = 4)
        {
            if (createGamePad)
            {
                useGamePad = createGamePad;
                uint id = GetFirstJoystick(maxGamepadChecks);

                if (id != uint.MaxValue)
                    gamepad = new GInput(id);
                
                else
                    useGamePad = false;
                
            }


            MInput.Init(game);
            KInput.Init();

        }

        private static uint GetFirstJoystick(uint maxGamepadChecks)
        {
            SFML.Window.Joystick.Update();
            List<uint> connectedIds = new List<uint>();

            for (uint i = 0; i < maxGamepadChecks; i++)
            {
                if (SFML.Window.Joystick.IsConnected(i))
                    return i;
            }


            return uint.MaxValue;
        }

        public static bool IsClicked(EAction action)
        {
            return false;
        }

        public static bool IsPressed(EAction action)
        {
            return false;
        }

        public static bool IsReleased(EAction action)
        {
            return false;
        }

        public static double GetPressTime(EAction action)
        {
            return 0.0;
        }

        public static void Update(GameTime gameTime)
        {
            KInput.Update(gameTime);
            MInput.Update(gameTime);

            if (useGamePad)
                gamepad.Update(gameTime);
            
        }
    }
}
