﻿using SFML.Window;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd.Input
{
    public abstract class KeyInfo
    {
        public double PressTime
        {
            get;
            protected set;
        }

        protected bool curPress;
        protected bool prevPress;


        public void Update(GameTime gameTime)
        {
            prevPress = curPress;
            curPress = CurrentlyPressed();

            if (curPress)
                PressTime += gameTime.ElapsedTime.TotalSeconds;

            else if (prevPress)
                PressTime = 0.0;
        }

        protected abstract bool CurrentlyPressed();
        
      

        public bool IsClicked()
        {
            return curPress && !prevPress;
        }

        public bool IsPressed()
        {
            return curPress;
        }

        public bool IsReleased()
        {
            return !curPress && prevPress;
        }

        public void Reset()
        {
            PressTime = 0.0;
            curPress = false;
            prevPress = false;
        }

    }
}
