﻿using SFML.Window;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd
{
    public static class Settings
    {
        public static Vector2i  WindowSize          { get; set; }
        public static Styles    Styles              { get; set; }
        public static uint      MaxFps              { get; set; }
        public static String    WindowTitle         { get; set; }
        public static bool      VSync               { get; set; }

        public static readonly IFormatProvider floatParseFormat = System.Globalization.CultureInfo.CreateSpecificCulture("en-us");


        public static void LoadSettings(String dataName)
        {
            string[] lines = File.ReadAllLines(dataName);
            string[] splitSymbols = { "=" };

            int windowWidth = 800;
            int windowHeight = 640;
            bool fullscreen = false;

            for (int i = 0; i < lines.Length; i++)
            {
                string[] parts = GetEntry(i, lines, splitSymbols);

                if (parts[0].Equals("Fullscreen"))
                    fullscreen = bool.Parse(parts[1]);

                else if (parts[0].Equals("VSync"))
                    VSync = bool.Parse(parts[1]);

                else if (parts[0].Equals("MaxFps"))
                    MaxFps = uint.Parse(parts[1]);

            }

            WindowSize = new Vector2i(windowWidth, windowHeight);

            if (fullscreen)
                Styles = Styles.Fullscreen;

            else
                Styles = Styles.Close | Styles.Titlebar;

            WindowTitle = "Bobble Crowd";
        }

        private static string[] GetEntry(int i, string[] lines, string[] splitSymbols)
        {
            return lines[i].Split(splitSymbols, StringSplitOptions.RemoveEmptyEntries);
        }
    }
}
