﻿using SFML.Graphics;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd
{
    public abstract class TextureDrawGroup : IDisposable, INameable
    {
        public String Name
        {
            get;
            set;
        }

        public RenderTexture target;


        public TextureDrawGroup(int width, int height, String name)
        {
            this.target = new RenderTexture((uint)width, (uint)height);
            this.Name = name;
        }

        public Texture GetTexture()
        {
            return target.Texture;
        }

        public abstract void Update(GameTime gameTime);

        public abstract void Draw(GameTime gameTime);

        public void Dispose()
        {
            target.Dispose();
        }
    }
}
