﻿using BobbleCrowd.Tiled;
using BobbleCrowd.World;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd
{
    public abstract class GameMode
    {
        protected GameWorld world;
        public int difficulty = 0;
        
        public GameMode(GameWorld world)
        {
            this.world = world;
        }

        public abstract void Update(GameTime gameTime);
        public abstract void PreChunkDraw(SFML.Graphics.RenderTarget target);
        public abstract void PostChunkDraw(SFML.Graphics.RenderTarget target);

        public abstract void Init(LevelReader reader);

        public abstract void ReceivedPoint();
    }
}
